<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
    <title>Sensor Configuration</title>

    <link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

    <script src='../js/meti_merged.js'></script>
    <script src='../js/meti_utils.js'></script>

    <style>
        #main_body {
            visibility: hidden;
        }

        label {
            margin-bottom: 0px;
        }

        .custom-checkbox {
            min-height: 1rem;
        }
    </style>

</head>


<body>
    <div id="main_body">
        <div w3-include-html="meti_bst.html"></div>

        <div class="container">
            <div class="row">
                <main role="main" class="col-sm-12 col-md-8 col-lg-6 pt-2">
                    <h5>Sensor Configuration</h5>
                    <div class="border border-primary p-2">
                        <div id="my_sensors">

                        </div>

                        <div class="form-group row">
                            <button type="button" id="button_cancel"
                                class="btn btn-warning col ml-4 mr-4">Cancel</button>
                            <button type="button" id="button_save" class="btn btn-success col ml-4 mr-4">Save</button>
                        </div>
                    </div>
                </main>
            </div>
        </div>
    </div>
</body>

<footer class="page-footer font-small blue pt-4">
    <div w3-include-html="footer.html"></div>
</footer>

</html>

<script>
    w3IncludeHTML();

    $(document).ready(function () {
        $("#main_body").css("visibility", "visible");
        var sensor_list;

        $("#button_cancel").on("click", function () {
            document.location.href = "index.html";
        });

        $("#button_save").on("click", function () {
            var r = confirm("Save sensor configuration?");
            if (r == true) {
                $.each(sensor_list, function (idx, val) {
                    val.nm = $('#sn_' + idx).val();
                    val.un = $('#un_' + idx).val();
                    val.dp =  $('#dp_' + idx + ' :selected').val();
                    val.di = $('#display_' + idx).is(":checked");
                });

                save_drivers();
            }
        });

        function displaySensors() {
            sensor_list = g_modbus_drivers.command.responseParser;
            var ctr = 0;
            // add cards to the deck from sensor list
            $.each(sensor_list, function (idx, val) {
                var sensor_div = $('<div></div>')
                    .attr('id', 'div_' + idx);

                var button_obj = $('<button></button>')
                    .attr('id', 'button_' + idx)
                    .html(val.nm)
                    .addClass("btn btn-sm btn-primary btn-block m-1")
                    .attr('data-toggle', 'collapse')
                    .attr('data-target', '#' + idx)
                    .attr('role', 'button')
                    .attr('aria-expanded', 'false')
                    .attr('aria-controls', idx)
                    .attr('title', 'Click to edit...')

                var div_card = $('<div></div>')
                    .addClass('collapse m-1 mb-3')
                    .attr('id', idx)

                // sensor parameters
                var div_card_body = $('<div></div>')
                    .addClass('card card-body p-1')

                //Sensor Name
                var div_form_grp = $('<div></div>')
                    .addClass('form-group p-0 m-1 row')

                var sn_label = $('<label></label>')
                    .addClass('col-sm-5 p-1')
                    .html('Sensor Name')

                var sn_input = $('<input></input>')
                    .attr('type', 'text')
                    .addClass('col-sm-7 form-control form-control-sm')
                    .attr('id', 'sn_' + idx)
                    .val(val.nm)

                div_form_grp.append(sn_label);
                div_form_grp.append(sn_input);
                div_card_body.append(div_form_grp)

                //unit_of_measure
                var div_form_grp = $('<div></div>')
                    .addClass('form-group p-0 m-1 row')

                var sn_label = $('<label></label>')
                    .addClass('col-sm-5 p-1')
                    .html('Unit of Measure')

                var sn_input = $('<input></input>')
                    .attr('type', 'text')
                    .addClass('col-sm-7 form-control form-control-sm')
                    .attr('id', 'un_' + idx)
                    .val(val.un)

                div_form_grp.append(sn_label);
                div_form_grp.append(sn_input);
                div_card_body.append(div_form_grp)

                //decimals
                var div_form_grp = $('<div></div>')
                    .addClass('form-group p-0 m-1 row')

                var dp_label = $('<label></label>')
                    .addClass('col-sm-5 p-1')
                    .html('Decimals')

                var dp_input = $('<select></select>')
                    .addClass('col-sm-7 form-control form-control-sm')
                    .attr('id', 'dp_' + idx)

                var dataArray = [0, 1, 2, 3, 4];
                for (idx1 = 0; idx1 < dataArray.length; idx1++) {
                    var opt = $('<option></option>')
                        .val(dataArray[idx1])
                        .addClass('dropdown-item')
                        .addClass('dd-item')
                        .text(dataArray[idx1]);
                    
                    if (val.dp == idx1) {
                        opt.attr("selected","selected")
                    }

                    dp_input.append(opt);
                }

                div_form_grp.append(dp_label);
                div_form_grp.append(dp_input);
                div_card_body.append(div_form_grp)

                //dashboard display
                var div_form_grp = $('<div></div>')
                    .addClass('form-group p-0 m-1 row')

                var sn_label = $('<label></label>')
                    .addClass('col-sm-5 p-1')
                    .html('Dashboard display')

                var sn_input = $('<input></input>')
                    .attr('type', 'checkbox')
                    .addClass('col-sm-1 custom-control custom-checkbox mt-2')
                    .attr('id', 'display_' + idx)
                    .attr('checked', val.di)

                div_form_grp.append(sn_label);
                div_form_grp.append(sn_input);
                div_card_body.append(div_form_grp)

                div_card_body.append(div_form_grp)

                div_card.append(div_card_body);
                sensor_div.append(button_obj);
                sensor_div.append(div_card);

                $("#my_sensors").append(sensor_div);

                // Just open the first sensor details....
                if (ctr == 0) {
                    $('#button_' + idx).click();
                }
                ctr++;
            });
        }

        function save_drivers() {
            var debug = 0;

            var driver_file = JSON.stringify(g_modbus_drivers);

            var data = {};
            data["driver_id"] = g_modbus_drivers.driver_id;

            MAX_POST_SIZE = 1000;
            var fileSize = driver_file.length;
            ctr = 0;
            while (fileSize > 0) {
                start = ctr * MAX_POST_SIZE;
                end = start + MAX_POST_SIZE;
                data["driver_file" + ctr] = driver_file.substring(start, end);
                fileSize = fileSize - MAX_POST_SIZE;
                ctr++;
            }
            data['driver_chunks'] = ctr;
            data['fileSize'] = driver_file.length;

            var url = "/saveNewModbusDriver";
            if (LOCAL_HOST == true) {
                url = "http://localhost/play/index.php/quickIoT/save_driver_to_device";
            }
            var type = 'POST';

            $.ajax({
                url: url,
                type: type,
                data: data,
                success: function (response) {
                    if (debug == 1) {
                        console.log(response);
                    }
                    else {
                        // console.log(js_response);
                        var result = response.result;

                        if (result == 1) {
                            alert(response.message);
                        }
                        else if (result == 0) {
                            alert(response.message);
                        }
                    }
                },
                error: function (jqXHR, exception, response) {
                    alert('POST Error!');
                }
            });
        }

        function load_form_data() {
            //None
        }

        function getActiveDriver() {
            g_currentDriver = '';

            var url = "/getActiveModbusDriver";
            if (LOCAL_HOST == true) {
                var url = "http://localhost/modbus/drivers/mmd_1.json";
            }

            var type = 'POST';
            var data = {
                app_key: "quickIoT"
            };

            // $("#loader_driver").css("display", "block");

            $.ajax({
                url: url,
                type: type,
                data: data,
                success: function (response) {
                    g_modbus_drivers = response;

                    if (typeof g_modbus_drivers.result === "undefined") {
                        // if proper driver response, list sensors
                        displaySensors();
                    } else {
                        // display error...
                        console.log(response.message);
                    }
                },
                error: function (jqXHR, exception, response) {
                    // $("#loader_driver").css("display", "none");
                    alert('POST Error!! Unable to get selected driver...');
                }
            });
        }

        //********* Call all start up functions after this line *******//
        // updateConfigFromFS(load_form_data);
        // Narayan this has to be changed (dynamic driver id)
        // getLocalModbusDrivers(displaySensors);

        setTimeout(function () {
            getActiveDriver();
        }, 1500);
    });
</script>